︠ad9f4e18-2295-47f2-ba3a-a8c914a9b964i︠
%md

Horizonal line test
︡11e8d646-0461-4be7-b93d-588eb837c6c4︡{"done":true,"md":"\nHorizonal line test"}
︠92b53c40-8a13-4476-aa35-7a50dddb4d93i︠
@interact
def _(f=x,horizontal_line_test=checkbox(default=false,label="Horizontal line test"),a=input_box(default=1,label="The horizontal line $y=$")):
    p=plot(f,-10,10)
    g=[p]
    S=(f==a).roots(ring=RR)
    if horizontal_line_test:
        horizontal_line=plot(a,-10,10,color='red')
        g.append(horizontal_line)
        if len(S)>1: 
            show("The function $f$ does not pass the horizonal line test")
        else:
            show("The function $f$ passes the horizonal line test")
    show(sum(g))

︡4a9bb8bd-cd23-46bd-9a34-97295fd7d380︡{"interact":{"controls":[{"control_type":"input-box","default":"x","label":"f","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"f","width":null},{"control_type":"checkbox","default":false,"label":"Horizontal line test","readonly":false,"var":"horizontal_line_test"},{"control_type":"input-box","default":1,"label":"The horizontal line $y=$","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"a","width":null}],"flicker":false,"id":"9ded4625-19c9-4ecc-9ccc-edd43326ca15","layout":[[["f",12,null]],[["horizontal_line_test",12,null]],[["a",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠01028c0f-e1b8-473f-b9b0-4b32be2a08e7i︠
%md

The natrual exponential function and the natural log are inverse to each other.
︡3e331378-49d0-48b1-8da3-695f9b3d3dd4︡{"done":true,"md":"\nThe natrual exponential function and the natural log are inverse to each other."}
︠9ccaeef6-3f1e-4e38-b4a9-8fa08a802f07si︠
@interact
def _(exponential=checkbox(label='$e^x$'), diagonal=checkbox(default=false,label='$y=x$'), logarithmic=checkbox(default=false,label='$\ln x$')):
    ex=plot(e^x,xmin=-4,xmax=4,ymin=-4,ymax=4)
    diag=plot((x,x),xmin=-4,xmax=4,ymin=-4,ymax=4)
    logx=plot(ln(x),xmin=0,xmax=4,ymin=-4,ymax=4)
    graphs=[]
    if exponential: graphs.append(ex)
    if diagonal: graphs.append(diag)
    if logarithmic: graphs.append(logx)
    sum(graphs).show(aspect_ratio=1,figsize=10)
︡d6be4dcd-8df0-4ad3-b157-7396df6c08c8︡{"interact":{"controls":[{"control_type":"checkbox","default":true,"label":"$e^x$","readonly":false,"var":"exponential"},{"control_type":"checkbox","default":false,"label":"$y=x$","readonly":false,"var":"diagonal"},{"control_type":"checkbox","default":false,"label":"$\\ln x$","readonly":false,"var":"logarithmic"}],"flicker":false,"id":"8e83b86f-91e4-4839-94a5-59ed3b62074b","layout":[[["exponential",12,null]],[["diagonal",12,null]],[["logarithmic",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠08811d33-ce93-4279-b826-575c01c9d6cci︠
%md

Thinking continuously
︡e2542b2f-26ba-4142-9c27-ab8f99795122︡{"done":true,"md":"\nThinking continuously"}
︠6839e02b-4765-4fde-b374-24b7cc578effi︠
from sage.plot.plot3d.plot3d import axes
v=vector((1,1,0))/sqrt(2)
Mx=matrix.ith_to_zero_rotation(v,1)
inverseMx=M.inverse()
xrotation= lambda a:matrix([[1,0,0],[0,cos(a),-sin(a)],[0,sin(a),cos(a)]])
n=20
Times=[i*pi/n for i in range(n)]
Objects=[inverseMx*xrotation(t)*Mx*vector((x,e^x,0)) for t in Times]
F=[]
for t in range(n):
    temp=parametric_plot3d(Objects[t],(x,-2,2),frame=false)
    temp+=axes(3,1,color='black')
    F.append(temp)
show(sum(F)+axes(3,1,color='black'),frame=false)
︡9049d9ce-7779-4e64-8ca3-3be424ff05a2︡{"file":{"filename":"6e16f7b6-3311-4885-ab6d-5f9ac7e2dd5a.sage3d","uuid":"6e16f7b6-3311-4885-ab6d-5f9ac7e2dd5a"}}︡{"done":true}︡︡{"done":true}









